## eccodes 2.6.0

=== CMakeLists.txt ===
#
# Copyright 2005-2017 ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
#
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.
#
###############################################################################
# cmake options:
#
#       -DCMAKE_BUILD_TYPE=Debug|RelWithDebInfo|Release|Production
#       -DCMAKE_INSTALL_PREFIX=/path/to/install
#
#       -DCMAKE_MODULE_PATH=/path/to/ecbuild/cmake

cmake_minimum_required( VERSION 2.8.11 FATAL_ERROR )

project( eccodes C )

set( CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild/cmake")

include( ecbuild_system NO_POLICY_SCOPE )

ecbuild_requires_macro_version( 2.7.2 )

###############################################################################
# local project

ecbuild_declare_project()

###############################################################################
# some variables/options of this project

ecbuild_add_option( FEATURE EXAMPLES
    DESCRIPTION "Build the examples"
    DEFAULT ON
)

ecbuild_add_option( FEATURE JPG
    DESCRIPTION "Support for JPG decoding/encoding"
    DEFAULT ON
)

ecbuild_add_option( FEATURE PNG
    DESCRIPTION "Support for PNG decoding/encoding"
    DEFAULT OFF
    REQUIRED_PACKAGES PNG
)

if( HAVE_PNG )
    set( HAVE_LIBPNG 1 ) # compatibility with autotools
    add_definitions( ${PNG_DEFINITIONS} )
else()
    set( HAVE_LIBPNG 0 )
endif()

ecbuild_add_option( FEATURE NETCDF
    DESCRIPTION "Support for GRIB to NetCDF conversion"
    DEFAULT ON
    REQUIRED_PACKAGES NetCDF
    NO_TPL
)

ecbuild_add_option( FEATURE AEC
    DESCRIPTION "Support for Adaptive Entropy Coding"
    DEFAULT OFF
    REQUIRED_PACKAGES AEC
)

ecbuild_add_option( FEATURE PYTHON
    DESCRIPTION "Build the ecCodes Python interface"
    DEFAULT ON
    REQUIRED_PACKAGES "Python VERSION 2.6 NO_LIBS" NumPy
)

ecbuild_add_option( FEATURE FORTRAN
    DESCRIPTION "Build the ecCodes Fortran interface"
    DEFAULT ON
    # REQUIRED_LANGUAGES Fortran # TODO
)

# TODO Remove this after REQUIRED_LANGUAGES
if( ENABLE_FORTRAN )
    # will set EC_HAVE_FORTRAN with the result
    ecbuild_enable_fortran( MODULE_DIRECTORY ${PROJECT_BINARY_DIR}/fortran/modules )
    set( HAVE_FORTRAN ${EC_HAVE_FORTRAN} )
else()
    set( HAVE_FORTRAN 0 )
endif()

# memfs requires only Python executable and not its libraries
ecbuild_add_option( FEATURE MEMFS
    DESCRIPTION "Memory based access to definitions/samples"
    DEFAULT OFF
    CONDITION EC_HAVE_FMEMOPEN OR EC_HAVE_FUNOPEN
    REQUIRED_PACKAGES PythonInterp
)

#if( HAVE_MEMFS AND "${CMAKE_C_COMPILER_ID}" STREQUAL "Cray")
#  set( HAVE_MEMFS OFF )
#  ecbuild_warn("MEMFS not supported with Cray C compiler")
#endif()

if(HAVE_MEMFS)
  set( _will_install_defs_samples OFF )
else()
  set( _will_install_defs_samples ON )
endif()

# controls installation of files in definitions/ -- note that it still creates the symlinks in the build dir
# by default, if memfs is available, then we don't need to install definitions
ecbuild_add_option( FEATURE INSTALL_ECCODES_DEFINITIONS
    DESCRIPTION "Install the ecCodes definitions"
    DEFAULT ${_will_install_defs_samples}
)

# controls installation of files in samples/ and ifs_samples/ -- note that it still creates the symlinks in the build dir
# by default, if memfs is available, then we don't need to install samples
ecbuild_add_option( FEATURE INSTALL_ECCODES_SAMPLES
    DESCRIPTION "Install the ecCodes samples, including IFS samples"
    DEFAULT ${_will_install_defs_samples}
)

# advanced options (not visible in cmake-gui )

ecbuild_add_option( FEATURE MEMORY_MANAGEMENT   DESCRIPTION "Enable memory management" DEFAULT OFF ADVANCED )
ecbuild_add_option( FEATURE ALIGN_MEMORY        DESCRIPTION "Enable memory alignment"  DEFAULT OFF ADVANCED )
ecbuild_add_option( FEATURE GRIB_TIMER          DESCRIPTION "Enable timer" DEFAULT OFF ADVANCED )
ecbuild_add_option( FEATURE ECCODES_THREADS     DESCRIPTION "Enable POSIX threads" DEFAULT OFF ADVANCED )
ecbuild_add_option( FEATURE ECCODES_OMP_THREADS DESCRIPTION "Enable OMP threads" DEFAULT OFF ADVANCED )
ecbuild_add_option( FEATURE EXTRA_TESTS         DESCRIPTION "Enable extended regression testing" DEFAULT OFF ADVANCED )

###############################################################################
# macro processing

set( ECCODES_EXTRA_LIBRARIES    "" )
set( ECCODES_EXTRA_INCLUDE_DIRS "" )
set( ECCODES_EXTRA_DEFINITIONS  "" )

find_package( CMath )
list( APPEND ECCODES_TPLS CMath )

### JPG support

set( HAVE_JPEG 0 )
set( HAVE_LIBJASPER 0 )
set( HAVE_LIBOPENJPEG 0 )

if( ENABLE_JPG )

    # Note: This is a deprecated feature but we need it to find Jasper at ECMWF.
    #       ecbuild_add_extra_search_paths modifies CMAKE_PREFIX_PATH
    #       which can affect future package discovery if not undone by the caller.
    #       The current CMAKE_PREFIX_PATH is backed up as _CMAKE_PREFIX_PATH
    #
    set(CMAKE_WARN_DEPRECATED OFF) # Suppress deprecation message
    ecbuild_add_extra_search_paths( jasper )
    find_package( Jasper )
    set(CMAKE_PREFIX_PATH ${_CMAKE_PREFIX_PATH})    # Restore CMAKE_PREFIX_PATH
    set(CMAKE_WARN_DEPRECATED ON)  # Remove suppression

    find_package( OpenJPEG )

    if( JASPER_FOUND )
        list( APPEND ECCODES_TPLS Jasper )
        set( HAVE_JPEG 1 )
        set( HAVE_LIBJASPER 1 )
        # Extract Jasper's major version number to enable conditional code. See ECC-396
        string(REGEX REPLACE "^([0-9]+)\\.[0-9]+\\.[0-9]+.*" "\\1" JASPER_VERSION_MAJOR "${JASPER_VERSION_STRING}")
    endif()

    if( OPENJPEG_FOUND )
        list( APPEND ECCODES_TPLS OpenJPEG )
        set( HAVE_JPEG 1 )
        set( HAVE_LIBOPENJPEG 1 )
    endif()

endif()


###############################################################################
# other options

if( HAVE_GRIB_TIMER )
    set( GRIB_TIMER 1 )
else()
    set( GRIB_TIMER 0 )
endif()

set( IS_BIG_ENDIAN 0 )
if( EC_BIG_ENDIAN )
    set( IS_BIG_ENDIAN 1 )
endif()

set( MANAGE_MEM 0 )
if( ENABLE_MEMORY_MANAGEMENT )
    set( MANAGE_MEM 1 )
endif()

set( CMAKE_THREAD_PREFER_PTHREAD 1 ) # find thread library, but prefer pthreads
find_package(Threads REQUIRED)

# debug
ecbuild_info(" CMAKE_THREAD_LIBS_INIT=${CMAKE_THREAD_LIBS_INIT}")
ecbuild_info(" CMAKE_USE_PTHREADS_INIT=${CMAKE_USE_PTHREADS_INIT}")
ecbuild_info(" HAVE_ECCODES_THREADS=${HAVE_ECCODES_THREADS}")


set( GRIB_PTHREADS 0 )
set( GRIB_OMP_THREADS 0 )
set( GRIB_LINUX_PTHREADS 0 )
#if( HAVE_ECCODES_THREADS AND CMAKE_THREAD_LIBS_INIT )
if( HAVE_ECCODES_THREADS )
    if( NOT ${CMAKE_USE_PTHREADS_INIT} )
        ecbuild_critical("Pthreads is not supported on your system: thread library found=[${CMAKE_THREAD_LIBS_INIT}]")
    endif()
    set( GRIB_PTHREADS 1 )
    if( ${CMAKE_SYSTEM_NAME} MATCHES "Linux" )
        set( GRIB_LINUX_PTHREADS 1 )
    endif()
elseif(HAVE_ECCODES_OMP_THREADS)
    ecbuild_enable_omp()
    set( GRIB_OMP_THREADS 1 )
endif()

# Cannot have both options
if( HAVE_ECCODES_THREADS AND HAVE_ECCODES_OMP_THREADS )
    ecbuild_critical("Cannot enable both POSIX threads and OMP! Please specify just one option")
endif()

ecbuild_info(" GRIB_PTHREADS=${GRIB_PTHREADS}")
ecbuild_info(" GRIB_OMP_THREADS=${GRIB_OMP_THREADS}")

set( GRIB_MEM_ALIGN 0 )
if( ENABLE_ALIGN_MEMORY )
  set( GRIB_MEM_ALIGN 1 )
endif()

# fix for #if IEEE_LE or IEE_BE instead of #ifdef

if( IEEE_BE )
    set( IEEE_LE 0 )
endif()

if( IEEE_LE )
    set( IEEE_BE 0 )
endif()

###############################################################################
# contents

if( NOT ${DEVELOPER_MODE} )
    set( the_default_data_prefix ${CMAKE_INSTALL_PREFIX} )
else()
    set( the_default_data_prefix ${CMAKE_BINARY_DIR} )
endif()

if( NOT DEFINED ECCODES_DEFINITION_SUFF )
  set( ECCODES_DEFINITION_SUFF  ${INSTALL_DATA_DIR}/definitions )
endif()
if( NOT DEFINED ECCODES_SAMPLES_SUFF )
  set( ECCODES_SAMPLES_SUFF     ${INSTALL_DATA_DIR}/samples )
endif()
if( NOT DEFINED ECCODES_IFS_SAMPLES_SUFF )
  set( ECCODES_IFS_SAMPLES_SUFF ${INSTALL_DATA_DIR}/ifs_samples )
endif()

set( ECCODES_DEFINITION_PATH  ${the_default_data_prefix}/${ECCODES_DEFINITION_SUFF} )
set( ECCODES_SAMPLES_PATH     ${the_default_data_prefix}/${ECCODES_SAMPLES_SUFF} )
set( ECCODES_IFS_SAMPLES_PATH ${the_default_data_prefix}/${ECCODES_IFS_SAMPLES_SUFF} )

### config header

ecbuild_generate_config_headers()

configure_file( eccodes_config.h.in eccodes_config.h )

add_definitions( -DHAVE_ECCODES_CONFIG_H )

install( FILES ${CMAKE_CURRENT_BINARY_DIR}/eccodes_config.h DESTINATION ${INSTALL_INCLUDE_DIR} )

if( CMAKE_COMPILER_IS_GNUCC )
    ecbuild_add_c_flags("-pedantic")
endif()

###############################################################################
# contents

### export package to other ecbuild packages

set( ECCODES_INCLUDE_DIRS    ${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/src ${CMAKE_CURRENT_BINARY_DIR}/src )
set( ECCODES_LIBRARIES       eccodes )

get_directory_property( COMPILE_DEFINITIONS ECCODES_DEFINITIONS )

foreach( _tpl ${ECCODES_TPLS} )
    string( TOUPPER ${_tpl} TPL )
    if( ${TPL}_FOUND )
        list( APPEND ECCODES_EXTRA_DEFINITIONS   ${${TPL}_DEFINITIONS} )
        list( APPEND ECCODES_EXTRA_INCLUDE_DIRS  ${${TPL}_INCLUDE_DIRS} ${${TPL}_INCLUDE_DIR} )
        list( APPEND ECCODES_EXTRA_LIBRARIES     ${${TPL}_LIBRARIES} )
    endif()
endforeach()

### include directories

include_directories( ${ECCODES_INCLUDE_DIRS}  ${ECCODES_EXTRA_INCLUDE_DIRS} )

add_subdirectory( definitions ) # must be before memfs
add_subdirectory( memfs )
add_subdirectory( src )
add_subdirectory( tools )
add_subdirectory( fortran )
add_subdirectory( python )
add_subdirectory( tests )
add_subdirectory( tigge )
add_subdirectory( examples )
add_subdirectory( data )
add_subdirectory( samples )
add_subdirectory( ifs_samples ) # must come after samples

# ecbuild_dont_pack( DIRS samples DONT_PACK_REGEX "*.grib" )
ecbuild_dont_pack( DIRS
     concepts tests.ecmwf doxygen confluence examples.dev templates parameters java
     perl config m4 rpms gaussian_experimental gribex examples/F77
     examples/extra examples/deprecated bamboo fortran/fortranCtypes tigge/tools
     share/eccodes  .settings
)
#ecbuild_dont_pack( DIRS data/bufr  DONT_PACK_REGEX "*.bufr" )
#ecbuild_dont_pack( DIRS data/tigge DONT_PACK_REGEX "*.grib" )

add_custom_target(dist COMMAND ${CMAKE_MAKE_PROGRAM} package_source)

###############################################################################
# export to other projects

# temporary -- add support for ecbuild 1.0.x sub-project inclusion
# to remove once mars server & client use eckit & ecbuild >= 1.1

if( EC_HAVE_FORTRAN )
    list( APPEND ECCODES_INCLUDE_DIRS  ${CMAKE_Fortran_MODULE_DIRECTORY} )
    list( APPEND ECCODES_LIBRARIES eccodes_f90 )
endif()

# Bundle
if( NOT PROJECT_NAME STREQUAL CMAKE_PROJECT_NAME )
  set( ECCODES_FOUND            TRUE PARENT_SCOPE )
  set( ECCODES_DEFINITIONS      ${ECCODES_DEFINITIONS}  PARENT_SCOPE )# includes already TPL definitions
  set( ECCODES_INCLUDE_DIRS     ${ECCODES_INCLUDE_DIRS} ${ECCODES_EXTRA_INCLUDE_DIRS} PARENT_SCOPE )
  set( ECCODES_LIBRARIES        ${ECCODES_LIBRARIES}    ${ECCODES_EXTRA_LIBRARIES} PARENT_SCOPE )
  set( ECCODES_INSTALL_EXTRA_TOOLS  ${ECCODES_INSTALL_EXTRA_TOOLS} PARENT_SCOPE )
  set( ECCODES_DEFINITION_PATH  ${CMAKE_BINARY_DIR}/${ECCODES_DEFINITION_SUFF}  PARENT_SCOPE )
  set( ECCODES_SAMPLES_PATH     ${CMAKE_BINARY_DIR}/${ECCODES_SAMPLES_SUFF}     PARENT_SCOPE )
  set( ECCODES_IFS_SAMPLES_PATH ${CMAKE_BINARY_DIR}/${ECCODES_IFS_SAMPLES_SUFF} PARENT_SCOPE )
endif()

# pkg-config
ecbuild_pkgconfig(
  NAME           eccodes
  URL            "https://software.ecmwf.int/wiki/display/ECC/"
  DESCRIPTION    "The ecCodes library"
  LIBRARIES      eccodes

=== definitions/CMakeLists.txt ===
file( GLOB definition_files RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} "*.def" )

set(definition_files ${definition_files} PARENT_SCOPE) # needed for memfs

file( GLOB table_files      RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} "*.table" )
file( GLOB text_files       RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} "*.txt" )

if(HAVE_INSTALL_ECCODES_DEFINITIONS)

  install( FILES ${definition_files} ${table_files} ${text_files}
           DESTINATION ${ECCODES_DEFINITION_SUFF}
           PERMISSIONS OWNER_WRITE OWNER_READ GROUP_READ WORLD_READ )

  install( FILES installDefinitions.sh
           DESTINATION ${ECCODES_DEFINITION_SUFF})

  install(  DIRECTORY budg bufr cdf common grib1 grib2 grib3 gts mars metar tide hdf5 wrap
            DESTINATION ${ECCODES_DEFINITION_SUFF}
            FILES_MATCHING
            PATTERN "*.def"
            PATTERN "*.txt"
            PATTERN "*.list"
            PATTERN "*.table"
            PATTERN "4.2.192.*.table" EXCLUDE
            PERMISSIONS OWNER_WRITE OWNER_READ GROUP_READ WORLD_READ )

endif()

# link to the definitions. See GRIB-786
file( MAKE_DIRECTORY ${CMAKE_BINARY_DIR}/${INSTALL_DATA_DIR} )
if( NOT EXISTS "${CMAKE_BINARY_DIR}/${ECCODES_DEFINITION_SUFF}" )
  execute_process( COMMAND "${CMAKE_COMMAND}" "-E" "create_symlink"
    "${CMAKE_CURRENT_SOURCE_DIR}"
    "${CMAKE_BINARY_DIR}/${ECCODES_DEFINITION_SUFF}" )
endif()

# copy the definitions to the build directory
#file(    COPY ${definition_files} ${table_files} ${text_files}
#         DESTINATION ${CMAKE_BINARY_DIR}/${ECCODES_DEFINITION_SUFF} )
#file(     COPY budg bufr cdf common grib1 grib2 grib3 gts mars metar tide hdf5 wrap
#          DESTINATION ${CMAKE_BINARY_DIR}/${ECCODES_DEFINITION_SUFF}
#          FILES_MATCHING
#          PATTERN "*.def"
#          PATTERN "*.txt"
#          PATTERN "*.list"
#          PATTERN "*.table"
#          PATTERN "4.2.192.*.table" EXCLUDE )

=== fortran/CMakeLists.txt ===
if( HAVE_FORTRAN )

    set( srcdir ${CMAKE_CURRENT_SOURCE_DIR} )
    set( bindir ${CMAKE_CURRENT_BINARY_DIR} )

    include_directories( ${srcdir} ${bindir} )

    ecbuild_add_executable( TARGET  grib_types
                            NOINSTALL
                            SOURCES grib_types.f90 grib_fortran_kinds.c )

    add_custom_command( OUTPUT  grib_kinds.h
                        COMMAND grib_types > grib_kinds.h
                        DEPENDS grib_types )

    if( ${EC_SIZEOF_INT} EQUAL ${EC_SIZEOF_LONG} )
        set( _long_int_interface    grib_f90_int.f90 )
        set( _long_int_interface_ec eccodes_f90_int.f90 )
    else()
        set( _long_int_interface    grib_f90_long_int.f90 )
        set( _long_int_interface_ec eccodes_f90_long_int.f90 )
    endif()

    if( ${EC_SIZEOF_INT} EQUAL ${EC_SIZEOF_SIZE_T} )
        set( _sizet_int_interface    grib_f90_int_size_t.f90 )
        set( _sizet_int_interface_ec eccodes_f90_int_size_t.f90 )
    else()
        set( _sizet_int_interface    grib_f90_long_size_t.f90 )
        set( _sizet_int_interface_ec eccodes_f90_long_size_t.f90 )
    endif()

    add_custom_command( OUTPUT  grib_f90.f90
                        COMMAND cat ${srcdir}/grib_f90_head.f90 ${srcdir}/${_long_int_interface} ${srcdir}/${_sizet_int_interface} ${srcdir}/grib_f90_tail.f90 > grib_f90.f90
                        DEPENDS grib_f90_head.f90 grib_f90_tail.f90 grib_kinds.h ${_long_int_interface} ${_sizet_int_interface} )
    add_custom_command( OUTPUT  eccodes_f90.f90
                        COMMAND cat ${srcdir}/eccodes_f90_head.f90 ${srcdir}/${_long_int_interface_ec} ${srcdir}/${_sizet_int_interface_ec} ${srcdir}/eccodes_f90_tail.f90 > eccodes_f90.f90
                        DEPENDS eccodes_f90_head.f90 eccodes_f90_tail.f90 grib_kinds.h ${_long_int_interface_ec} ${_sizet_int_interface_ec} )

    #ecbuild_add_library( TARGET     eccodes_f77
    #                     SOURCES    grib_fortran.c grib_f77.c
    #                     LIBS       eccodes )

    ecbuild_add_library( TARGET     eccodes_f90
                         SOURCES    grib_fortran.c grib_f90.f90 eccodes_f90.f90 grib_kinds.h
                         GENERATED  grib_f90.f90 eccodes_f90.f90
                         LIBS       eccodes )
    add_custom_command( TARGET     eccodes_f90 POST_BUILD
                        COMMAND ${CMAKE_COMMAND} -E make_directory ${CMAKE_BINARY_DIR}/include
                        COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_Fortran_MODULE_DIRECTORY}/${CMAKE_CFG_INTDIR}/eccodes.mod ${CMAKE_BINARY_DIR}/include
                        COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_Fortran_MODULE_DIRECTORY}/${CMAKE_CFG_INTDIR}/grib_api.mod ${CMAKE_BINARY_DIR}/include
    )

    # Add the eccodes module file as well
    #set(_eccodes_mod "${CMAKE_Fortran_MODULE_DIRECTORY}/eccodes.mod" )

    #add_custom_command(
    #    OUTPUT ${_eccodes_mod}
    #    WORKING_DIRECTORY ${CMAKE_Fortran_MODULE_DIRECTORY}
    #    #COMMAND ${CMAKE_COMMAND} -E create_symlink "${CMAKE_Fortran_MODULE_DIRECTORY}/grib_api.mod" ${_eccodes_mod}
    #    #COMMAND ${CMAKE_COMMAND} -E copy "${CMAKE_Fortran_MODULE_DIRECTORY}/grib_api.mod" ${_eccodes_mod}
    #    COMMAND "/usr/bin/sh" "-c" "if test -f GRIB_API.mod; then ln -s GRIB_API.mod ECCODES.mod; fi"
    #    COMMAND "/usr/bin/sh" "-c" "if test -f grib_api.mod; then ln -s grib_api.mod eccodes.mod; fi"
    #   DEPENDS eccodes_f90
    #    VERBATIM
    #)
    #add_custom_target(add_eccodes_mod ALL DEPENDS ${_eccodes_mod})

    ecbuild_add_resources( TARGET fortran_resources
                           PACK
                            grib_fortran_prototypes.h grib_api_constants.h grib_api_externals.h
                            grib_api_visibility.h grib_types.f90 create_grib_f90.sh
                            grib_f90.f90.head grib_f90.f90.tail grib_f90_int.f90 grib_f90_long_int.f90
                            grib_f90_int_size_t.f90 grib_f90_long_size_t.f90

                            eccodes_visibility.h eccodes_constants.h
                            eccodes_f90.f90.head eccodes_f90.f90.tail eccodes_f90_int.f90 eccodes_f90_long_int.f90
                            eccodes_f90_int_size_t.f90 eccodes_f90_long_size_t.f90

                            same_int_long.f90 same_int_size_t.f90 grib_fortran_kinds.c )



### installation

    # Install the generated .mod file
    # install( CODE "EXECUTE_PROCESS (COMMAND ${CMAKE_COMMAND} -E copy_directory ${CMAKE_Fortran_MODULE_DIRECTORY}/${CMAKE_CFG_INTDIR} ${CMAKE_INSTALL_PREFIX}/${INSTALL_INCLUDE_DIR})" )

    # Install the contents of the fortran module directory
    if(ECBUILD_INSTALL_FORTRAN_MODULES)
        install( DIRECTORY ${CMAKE_Fortran_MODULE_DIRECTORY}/${CMAKE_CFG_INTDIR}/  DESTINATION ${INSTALL_INCLUDE_DIR} )
    endif()

    # Install the eccodes module file as a copy of the grib api mod file.
    # Note: the mod filename can be lowercase or uppercase!
    # First try the lowercase one. Specify OPTIONAL so if it fails it carries on
    #install( FILES ${CMAKE_Fortran_MODULE_DIRECTORY}/${CMAKE_CFG_INTDIR}/grib_api.mod
    #                 RENAME eccodes.mod
    #                 OPTIONAL
    #                 DESTINATION ${INSTALL_INCLUDE_DIR} )
    # Now try the uppercase mod file
    #install( FILES ${CMAKE_Fortran_MODULE_DIRECTORY}/${CMAKE_CFG_INTDIR}/GRIB_API.mod
    #                 RENAME ECCODES.mod
    #                 OPTIONAL
    #                 DESTINATION ${INSTALL_INCLUDE_DIR} )

endif()

=== ifs_samples/CMakeLists.txt ===
function( install_samples samples destination_install destination_build )
  set( _samples ${${samples}} )

  if(HAVE_INSTALL_ECCODES_SAMPLES)

    # To install the samples
    install( FILES  ${_samples}
             DESTINATION ${destination_install}
             PERMISSIONS OWNER_WRITE OWNER_READ GROUP_READ WORLD_READ )

  endif()

  # To symlink the samples to the build-dir for developers
  execute_process( COMMAND ${CMAKE_COMMAND} -E make_directory ${destination_build} )
  foreach( _file ${_samples} )
    get_filename_component(_filename ${_file} NAME)
    execute_process( COMMAND ${CMAKE_COMMAND} -E create_symlink
       ${_file} ${destination_build}/${_filename} )
  endforeach()
endfunction()

add_subdirectory( grib1 )

add_subdirectory( grib1_mlgrib2 )

# add_subdirectory( grib1_mlgrib2_ieee32 )

add_subdirectory( grib1_mlgrib2_ieee64 )

=== python/CMakeLists.txt ===
if( HAVE_PYTHON )

    #find_package( SWIG )
    #if( SWIG_FOUND )
    #    include( ${SWIG_USE_FILE} )
    #endif()

    # preparing for generating setup.py
    if( HAVE_LIBJASPER )
        get_filename_component(JASPER_DIR ${JASPER_INCLUDE_DIR} PATH )
    endif()

    if( HAVE_LIBOPENJPEG )
        # Get the name of the OpenJPEG library: version dependent!
        # E.g. openjpeg (version 1.5) or openjp2 (version 2.x)
        get_filename_component(OPENJPEG_LIB_DIR ${OPENJPEG_LIBRARY} PATH )
        get_filename_component(OJ_NAME_WE       ${OPENJPEG_LIBRARY} NAME_WE )
        STRING(REGEX REPLACE "^lib" "" OJ_WITHOUT_LIB ${OJ_NAME_WE})
    endif()

    if( HAVE_AEC )
      get_filename_component(AEC_DIR ${AEC_INCLUDE_DIR} PATH )
    endif()

    configure_file( setup.py.in setup.py )

    # compile swig interface
    # set(CMAKE_SWIG_FLAGS "")
    # set_source_files_properties( gribapi_swig.i PROPERTIES C ON )

    # if( NUMPY_FOUND )
    #     set( CMAKE_SWIG_FLAGS "-DNUMPY" )
    #     include_directories( ${NUMPY_INCLUDE_DIRS} )
    # endif()

    ####### Do not invoke swig. Use our own generated C wrapper file ######
    set( _gribapi_swig "gribapi/_gribapi_swig${CMAKE_SHARED_LIBRARY_SUFFIX}" )
    # Build the extension module for use in build tree with RPATH pointing to the build tree
    add_custom_command( OUTPUT ${_gribapi_swig}
                        COMMAND ${PYTHON_EXECUTABLE} setup.py build_ext --inplace --rpath ${CMAKE_BINARY_DIR}/lib
                        DEPENDS grib_interface.h grib_interface.c swig_wrap_numpy.c setup.py.in eccodes )
    add_custom_target(eccodes_build_swig_wrapper ALL DEPENDS ${_gribapi_swig})

    #ecbuild_add_library(TARGET    _gribapi_swig
    #                    TYPE SHARED
    #                    NOINSTALL
    #                    SOURCES   grib_interface.h grib_interface.c swig_wrap_numpy.c
    #                    INCLUDES  ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR} ${PYTHON_INCLUDE_DIRS}
    #                    LIBS      eccodes ${PYTHON_LIBRARIES} )
    # Don't use the lib prefix.  This is needed for the python case where a _modulename.so is generated
    #set_target_properties(_gribapi_swig PROPERTIES PREFIX "")

    # Copy gribapi and eccodes python modules to build area
    file( COPY eccodes gribapi DESTINATION . )
    configure_file( swig_wrap_numpy.py gribapi/gribapi_swig.py COPYONLY )

    # Build the extension module for use in install tree with RPATH pointing to install tree
    install(CODE "message(\"Building Python extension modules:
${PYTHON_EXECUTABLE} setup.py build_ext --rpath ${CMAKE_INSTALL_PREFIX}/${INSTALL_LIB_DIR}\")
                  execute_process(COMMAND ${PYTHON_EXECUTABLE} setup.py build_ext --rpath ${CMAKE_INSTALL_PREFIX}/${INSTALL_LIB_DIR}
                                  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})")

    # Library installation directory override
    if( NOT INSTALL_LIB_DIR STREQUAL lib )
      execute_process( COMMAND ${PYTHON_EXECUTABLE} -c "from __future__ import print_function; import sys; print(sys.version[:3], end='')"
                       OUTPUT_VARIABLE PYVER )
      set( __install_lib "--install-lib=${ECCODES_FULL_INSTALL_LIB_DIR}/python${PYVER}/site-packages" )
    endif()

    # Call distutils for installation
    install(CODE "if( NOT \$ENV{DESTDIR} STREQUAL \"\" )
                    set( __root \"--root=\$ENV{DESTDIR}\" )
                  endif()
                  message(\"Installing Python modules:
${PYTHON_EXECUTABLE} setup.py install \${__root}
                                      ${__install_lib}
                                      --prefix=${CMAKE_INSTALL_PREFIX}
                                      --record=${CMAKE_BINARY_DIR}/extra_install.txt\")
                  execute_process(COMMAND ${PYTHON_EXECUTABLE} setup.py install
                                            \${__root}
                                            --prefix=${CMAKE_INSTALL_PREFIX}
                                            ${__install_lib}
                                            --record=${CMAKE_BINARY_DIR}/extra_install.txt
                                  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})")

endif()

=== src/CMakeLists.txt ===
#
# Copyright 2005-2017 ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
#
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.
#
list( APPEND grib_api_srcs
    grib_api.h
    eccodes.h
    action.c
    action_class_alias.c
    action_class_gen.c
    action_class_if.c
    action_class_switch.c
    grib_accessor_class_g1fcperiod.c
    grib_accessor_class_g1end_of_interval_monthly.c
    grib_accessor_class_mars_param.c
    action_class_section.c
    action_class_list.c
    action_class_while.c
    action_class_put.c
    action_class_meta.c
    action_class_remove.c
    action_class_rename.c
    action_class_assert.c
    action_class_template.c
    action_class_trigger.c
    action_class_when.c
    action_class_concept.c
    action_class_hash_array.c
    action_class_set.c
    action_class_set_sarray.c
    action_class_set_darray.c
    action_class_set_iarray.c
    action_class_noop.c
    action_class_write.c
    action_class_print.c
    action_class_close.c
    action_class_variable.c
    action_class_modify.c
    action_class_transient_darray.c
    eccodes.c
    grib_accessor.c
    grib_concept.c
    grib_hash_array.c
    grib_bufr_descriptor.c
    grib_bufr_descriptors_array.c
    grib_darray.c
    grib_sarray.c
    grib_oarray.c
    grib_vdarray.c
    grib_vsarray.c
    grib_iarray.c
    grib_viarray.c
    codes_memfs.c
    grib_accessor_class_array.c
    grib_accessor_class_assert.c
    grib_accessor_class_ascii.c
    grib_accessor_class_bit.c
    grib_accessor_class_bitmap.c
    grib_accessor_class_bits.c
    grib_accessor_class_bits_per_value.c
    grib_accessor_class_bufr_clear_tables.c
    grib_accessor_class_bufr_data.c
    grib_accessor_class_bufr_elements_table.c
    grib_accessor_class_bufr_data_array.c
    grib_accessor_class_bufr_data_element.c
    grib_accessor_class_bufr_group.c
    grib_accessor_class_bufr_string_values.c
    grib_accessor_class_pack_bufr_values.c
    grib_accessor_class_unpack_bufr_values.c
    grib_accessor_class_bufr_has_delayed_replication.c
    grib_accessor_class_apply_operators.c
    grib_accessor_class_group.c
    grib_accessor_class_non_alpha.c
    grib_accessor_class_g1bitmap.c
    grib_accessor_class_g2bitmap.c
    grib_accessor_class_concept.c
    grib_accessor_class_hash_array.c
    grib_accessor_class_decimal_precision.c
    grib_accessor_class_divdouble.c
    grib_accessor_class_budgdate.c
    grib_accessor_class_validity_date.c
    grib_accessor_class_validity_time.c
    grib_accessor_class_bytes.c
    grib_accessor_class.c
    grib_accessor_class_change_scanning_direction.c
    grib_accessor_class_check_internal_version.c
    grib_accessor_class_codeflag.c
    grib_accessor_class_smart_table.c
    grib_accessor_class_smart_table_column.c
    grib_accessor_class_codetable.c
    grib_accessor_class_codetable_units.c
    grib_accessor_class_codetable_title.c
    grib_accessor_class_count_file.c
    grib_accessor_class_count_total.c
    grib_accessor_class_double.c
    grib_accessor_class_element.c
    grib_accessor_class_evaluate.c
    grib_accessor_class_g1area.c
    grib_accessor_class_g1date.c
    grib_accessor_class_g1monthlydate.c
    grib_accessor_class_library_version.c
    grib_accessor_class_when.c
    grib_accessor_class_g1verificationdate.c
    grib_accessor_class_g1day_of_the_year_date.c
    grib_accessor_class_g1_half_byte_codeflag.c
    grib_accessor_class_g1forecastmonth.c
    grib_accessor_class_g1step_range.c
    grib_accessor_class_g2step_range.c
    grib_accessor_class_data_g22order_packing.c
    grib_accessor_class_mars_step.c
    grib_accessor_class_message_copy.c
    grib_accessor_class_dictionary.c
    grib_accessor_class_g1param.c
    grib_accessor_class_g1p1p2.c
    grib_accessor_class_g1_increment.c
    grib_accessor_class_latlon_increment.c
    grib_accessor_class_g2date.c
    grib_accessor_class_g2level.c
    grib_accessor_class_g2step.c
    grib_accessor_class_g2end_step.c
    grib_accessor_class_g2latlon.c
    grib_accessor_class_g2lon.c
    grib_accessor_class_global_gaussian.c
    grib_accessor_class_gaussian_grid_name.c
    grib_accessor_class_gen.c
    grib_accessor_class_getenv.c
    grib_accessor_class_gts_header.c
    grib_accessor_class_ifs_param.c
    grib_accessor_class_julian_day.c
    grib_accessor_class_julian_date.c
    grib_accessor_class_latlonvalues.c
    grib_accessor_class_latitudes.c
    grib_accessor_class_longitudes.c
    grib_accessor_class_missing.c
    grib_accessor_class_offset_file.c
    grib_accessor_class_scale.c
    grib_accessor_class_from_scale_factor_scaled_value.c
    grib_accessor_class_times.c
    grib_accessor_class_forward.c
    grib_accessor_class_g2bitmap_present.c
    grib_accessor_class_ibmfloat.c
    grib_accessor_class_ieeefloat.c
    grib_accessor_class_constant.c
    grib_accessor_class_iterator.c
    grib_accessor_class_message.c
    grib_accessor_class_nearest.c
    grib_accessor_class_box.c
    grib_accessor_class_ksec1expver.c
    grib_accessor_class_laplacian.c
    grib_accessor_class_label.c
    grib_accessor_class_long.c
    grib_accessor_class_lookup.c
    grib_accessor_class_octahedral_gaussian.c
    grib_accessor_class_octect_number.c
    grib_accessor_class_headers_only.c
    grib_accessor_class_padding.c
    grib_accessor_class_pad.c
    grib_accessor_class_padto.c
    grib_accessor_class_padtoeven.c
    grib_accessor_class_padtomultiple.c
    grib_accessor_class_section_padding.c
    grib_accessor_class_section_pointer.c
    grib_accessor_class_position.c
    grib_accessor_class_signed.c
    grib_accessor_class_signed_bits.c
    grib_accessor_class_section.c
    grib_accessor_class_step_in_units.c
    grib_accessor_class_section_length.c
    grib_accessor_class_g1_message_length.c
    grib_accessor_class_g1_section4_length.c
    grib_accessor_class_size.c
    grib_accessor_class_rdbtime_guess_date.c
    grib_accessor_class_scale_values.c
    grib_accessor_class_offset_values.c
    grib_accessor_class_sprintf.c
    grib_accessor_class_round.c
    grib_accessor_class_spectral_truncation.c
    grib_accessor_class_time.c
    grib_accessor_class_transient.c
    grib_accessor_class_transient_darray.c
    grib_accessor_class_values.c
    grib_accessor_class_simple_packing_error.c
    grib_accessor_class_data_simple_packing.c
    grib_accessor_class_count_missing.c
    grib_accessor_class_data_sh_packed.c
    grib_accessor_class_data_sh_unpacked.c
    grib_accessor_class_number_of_values_data_raw_packing.c
    grib_accessor_class_data_g1simple_packing.c
    grib_accessor_class_data_g1shsimple_packing.c
    grib_accessor_class_data_shsimple_packing.c
    grib_accessor_class_data_constant_field.c
    grib_accessor_class_data_dummy_field.c
    grib_2order_packer_simple.c
    grib_accessor_class_variable.c
    grib_accessor_class_second_order_bits_per_value.c
    grib_accessor_class_data_g2simple_packing.c
    grib_accessor_class_data_g2simple_packing_with_preprocessing.c
    grib_accessor_class_data_g2shsimple_packing.c
    grib_accessor_class_data_g2complex_packing.c
    grib_accessor_class_data_2order_packing.c
    grib_accessor_class_data_2order_packing_count.c
    grib_accessor_class_data_g1second_order_row_by_row_packing.c
    grib_accessor_class_data_g1second_order_constant_width_packing.c
    grib_accessor_class_data_g1second_order_general_packing.c
    grib_accessor_class_data_g1second_order_general_extended_packing.c
    grib_accessor_class_g2grid.c
    grib_accessor_class_unexpanded_descriptors.c
    grib_accessor_class_expanded_descriptors.c
    grib_accessor_class_bufrdc_expanded_descriptors.c
    grib_accessor_class_data_apply_bitmap.c
    grib_accessor_class_data_apply_boustrophedonic.c
    grib_accessor_class_data_apply_boustrophedonic_bitmap.c
    grib_accessor_class_data_secondary_bitmap.c
    grib_accessor_class_data_g1secondary_bitmap.c
    grib_accessor_class_data_g2secondary_bitmap.c
    grib_accessor_class_data_jpeg2000_packing.c
    grib_accessor_class_data_png_packing.c
    grib_accessor_class_data_ccsds_packing.c
    grib_accessor_class_data_raw_packing.c
    grib_accessor_class_data_complex_packing.c
    grib_accessor_class_data_g1complex_packing.c
    grib_accessor_class_gds_not_present_bitmap.c
    grib_accessor_class_data_apply_gdsnotpresent.c
    grib_accessor_class_gds_is_present.c
    grib_accessor_class_select_step_template.c
    grib_accessor_class_local_definition.c
    grib_accessor_class_g2_eps.c
    grib_accessor_class_g2_chemical.c
    grib_accessor_class_g2_mars_labeling.c
    grib_accessor_class_md5.c
    grib_jasper_encoding.c
    grib_openjpeg_encoding.c
    action_class_set_missing.c
    grib_accessor_class_number_of_points.c
    grib_accessor_class_suppressed.c
    grib_index.c
    grib_accessor_class_number_of_points_gaussian.c
    grib_accessor_class_number_of_values.c
    grib_accessor_class_number_of_coded_values.c
    grib_accessor_class_g1number_of_coded_values_sh_complex.c
    grib_accessor_class_g1number_of_coded_values_sh_simple.c
    grib_accessor_class_dirty.c
    grib_accessor_class_statistics.c
    grib_accessor_class_statistics_spectral.c
    grib_accessor_class_unsigned.c
    grib_accessor_class_unsigned_bits.c
    grib_accessor_class_raw.c
    grib_accessor_class_bufr_simple_thinning.c
    grib_accessor_class_bufr_extract_subsets.c
    grib_accessor_class_bufr_extract_area_subsets.c
    grib_accessor_class_bufr_extract_datetime_subsets.c
    grib_accessor_class_spd.c
    grib_accessor_class_sum.c
    grib_accessor_class_to_integer.c
    grib_accessor_class_to_double.c
    grib_accessor_class_to_string.c
    grib_accessor_class_sexagesimal2decimal.c
    grib_accessor_class_vector.c
    grib_accessor_class_long_vector.c
    grib_gaussian_reduced.c
    grib_accessor_class_abstract_vector.c
    grib_accessor_class_abstract_long_vector.c
    grib_loader_from_handle.c
    grib_bits.c
    grib_timer.c
    grib_ibmfloat.c
    grib_ieeefloat.c
    grib_accessor_class_reference_value_error.c
    grib_memory.c
    grib_buffer.c
    grib_dumper.c
    grib_dumper_class_serialize.c
    grib_dumper_class_debug.c
    grib_dumper_class_default.c
    grib_dumper_class_keys.c
    grib_dumper_class_bufr_encode_C.c
    grib_dumper_class_bufr_encode_filter.c
    grib_dumper_class_bufr_encode_fortran.c
    grib_dumper_class_bufr_encode_python.c
    grib_dumper_class_bufr_decode_C.c
    grib_dumper_class_bufr_decode_filter.c
    grib_dumper_class_bufr_decode_fortran.c
    grib_dumper_class_bufr_decode_python.c
    grib_dumper_class_bufr_simple.c
    grib_dumper_class_json.c
    grib_dumper_class_grib_encode_C.c
    grib_dumper_class_wmo.c
    grib_dumper_class.c
    grib_context.c
    grib_date.c
    grib_fieldset.c
    grib_filepool.c
    grib_geography.c
    grib_handle.c
    grib_header_compute.c
    grib_hash_keys.c
    grib_io.c
    grib_trie.c
    grib_trie_with_rank.c
    grib_itrie.c
    grib_rules.c
    grib_keys_iterator.c
    bufr_keys_iterator.c
    grib_parse_utils.c
    grib_query.c
    grib_scaling.c
    grib_templates.c
    grib_dependency.c
    grib_value.c
    grib_errors.c
    grib_expression_class_binop.c
    grib_expression_class_logical_and.c
    grib_expression_class_logical_or.c
    grib_expression_class_is_in_dict.c
    grib_expression_class_true.c
    grib_expression_class_string_compare.c
    grib_expression_class_unop.c
    grib_expression_class_functor.c
    grib_expression_class_accessor.c
    grib_expression_class_is_in_list.c
    grib_expression_class_is_integer.c
    grib_expression_class_length.c
    grib_expression_class_long.c
    grib_expression_class_double.c
    grib_expression_class_string.c
    grib_expression_class_sub_string.c
    grib_box.c
    grib_box_class.c
    grib_box_class_gen.c

=== tests/CMakeLists.txt ===
# tests/CMakeLists.txt
#
# Configure the file which all CMake tests will include
configure_file( include.ctest.sh.in  include.ctest.sh @ONLY )

execute_process( COMMAND ${CMAKE_COMMAND} -E copy_if_different ${CMAKE_CURRENT_SOURCE_DIR}/include.sh ${CMAKE_CURRENT_BINARY_DIR} )
execute_process( COMMAND ${CMAKE_COMMAND} -E copy_if_different ${CMAKE_CURRENT_SOURCE_DIR}/utils.sh   ${CMAKE_CURRENT_BINARY_DIR} )
execute_process( COMMAND ${CMAKE_COMMAND} -E copy_if_different ${CMAKE_CURRENT_SOURCE_DIR}/number_compare.pl ${CMAKE_CURRENT_BINARY_DIR} )

# Build the executables used by test scripts
################################################
list( APPEND test_bins
      grib_double_cmp
      read_any
      julian
      index
      multi_from_message
      read_index
      unit_tests
      bufr_keys_iter
      gauss_sub
      grib_util_set_spec
      local_MeteoFrance
      grib_2nd_order_numValues
      optimize_scaling
      optimize_scaling_sh
      ecc-386
      ecc-517
      bufr_get_element
      sh_ieee64
      ieee
)

foreach( tool ${test_bins} )
    # here we use the fact that each tool has only one C file that matches its name
    ecbuild_add_executable( TARGET    ${tool}
                            NOINSTALL
                            SOURCES   ${tool}.c
                            LIBS      eccodes
    )
endforeach()

# Now add each test (shell scripts)
#################################################
# These tests do not require any data downloads
list( APPEND tests_no_data_reqd
    definitions
    calendar
    unit_tests
    md5
    uerra
    grib_2nd_order_numValues
    julian
    ecc-517
)
# These tests do require data downloads
list( APPEND tests_data_reqd
    grib_double_cmp
    bufr_dump
    bufr_dump_decode_filter
    bufr_dump_encode_filter
    bufrdc_desc_ref
    bufrdc_ref
    bufr_compare
    bufr_copy
    bufr_count
    bufr_get
    bufr_filter
    bufr_filter_extract_datetime
    bufr_filter_extract_area
    bufr_json
    bufr_ls
    bufr_change_edition
    bufr_keys_iter
    bufr_get_element
    bufr_wmo_tables
    ecc-197
    ecc-286
    ecc-288
    ecc-313
    ecc-379
    ecc-393
    ecc-433
    ecc-490
    ecc-556
    gts_get
    gts_ls
    gts_compare
    metar_ls
    metar_get
    metar_dump
    metar_compare
    bufr_set
    ieee
    sh_ieee64
    optimize_scaling
    optimize_scaling_sh
    grib1to2
    grib2to1
    grib1to3
    grib2to3
    grib3_templates
    badgrib
    grib_ls
    grib_filter
    grib_multi
    budg
    gridType
    grib_octahedral
    grib_global
    grib_concept
    decimalPrecision
    grib_bitsPerValue
    get_fail
    missing
    grib_local
    grib_step
    grib_set
    grib_iterator
    grib_compare
    grib_level
    index
    grib_bitmap
    list
    grib_second_order
    multi_from_message
    grib_change_scanning
    grib_statistics
    tigge
    tigge_conversions
    read_any
    grib_padding
    grib_dump
    grib_dump_debug
    grib_util_set_spec
    local_MeteoFrance
    grib_neg_fctime
    codes_split_file
)
if( HAVE_FORTRAN AND ENABLE_EXTRA_TESTS )
    list(APPEND tests_data_reqd bufr_dump_encode_fortran)
    list(APPEND tests_data_reqd bufr_dump_decode_fortran)
endif()
if( ENABLE_EXTRA_TESTS )
    list(APPEND tests_data_reqd bufr_dump_encode_C)
    list(APPEND tests_data_reqd bufr_dump_decode_C)
endif()

# These tests do not require any data downloads
foreach( test ${tests_no_data_reqd} )
    ecbuild_add_test( TARGET eccodes_t_${test}
                      TYPE SCRIPT
                      COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/${test}.sh
    )
endforeach()
ecbuild_add_test( TARGET eccodes_t_check_gaussian_grids
                  TYPE SCRIPT
                  CONDITION  ECCODES_INSTALL_EXTRA_TOOLS
                  COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/check_gaussian_grids.sh
)


# Note: making the test dependent on the grib files (with DEPENDS)
#       means they will be downloaded at "make" time
#       rather than when you do "ctest". Use TEST_DEPENDS instead
foreach( test ${tests_data_reqd} )
    ecbuild_add_test( TARGET eccodes_t_${test}
                  TYPE SCRIPT
                  COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/${test}.sh
                  RESOURCES asca_139.t1.ref
                  TEST_DEPENDS eccodes_download_gribs eccodes_download_tigge_gribs
                               eccodes_download_bufrs eccodes_download_metars eccodes_download_gts
    )
endforeach()

if( HAVE_FORTRAN AND ENABLE_EXTRA_TESTS )
    set_tests_properties ( eccodes_t_bufr_dump_encode_fortran PROPERTIES TIMEOUT 2500)
endif()
if( ENABLE_EXTRA_TESTS )
    set_tests_properties ( eccodes_t_bufr_dump_encode_C PROPERTIES TIMEOUT 2500)
endif()


if( HAVE_PYTHON AND ENABLE_EXTRA_TESTS )
    list( APPEND ptests bufr_dump_encode_python bufr_dump_decode_python )
    foreach( test ${ptests} )
        ecbuild_add_test( TARGET eccodes_t_${test}
                          TYPE SCRIPT
                          COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/${test}.sh
                          ENVIRONMENT PYTHON=${PYTHON_EXECUTABLE} PYTHONPATH=${PROJECT_BINARY_DIR}/python
                          TEST_DEPENDS eccodes_download_bufrs
        )
    endforeach()
endif()

###########################################
# Note: the reference file is in the tests dir not data dir!
ecbuild_add_test( TARGET eccodes_t_lamb_az_eq_area
                  TYPE SCRIPT
                  COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/lamb_az_eq_area.sh
                  RESOURCES lamb_az_eq_area.ref
                  TEST_DEPENDS eccodes_download_gribs
)

# These ones are conditional
###########################################
if( ENABLE_EXTRA_TESTS AND HAVE_ECCODES_THREADS )
    ecbuild_add_executable( TARGET    grib_encode_pthreads
                            NOINSTALL
                            SOURCES   grib_encode_pthreads.c
                            LIBS      eccodes
    )
    ecbuild_add_test( TARGET eccodes_t_grib_encode_pthreads
                      TYPE SCRIPT
                      COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/grib_encode_pthreads.sh
    )
endif()

ecbuild_add_test( TARGET eccodes_t_grib_to_netcdf
                  TYPE SCRIPT
                  CONDITION HAVE_NETCDF
                  COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/grib_to_netcdf.sh
                  TEST_DEPENDS eccodes_download_gribs
)

ecbuild_add_test( TARGET eccodes_t_grib_jpeg
                  TYPE SCRIPT
                  CONDITION HAVE_JPEG
                  COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/grib_jpeg.sh
                  TEST_DEPENDS eccodes_download_gribs
)

ecbuild_add_test( TARGET eccodes_t_grib_png
                  TYPE SCRIPT
                  CONDITION HAVE_PNG
                  COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/grib_png.sh
                  TEST_DEPENDS eccodes_download_gribs
)

ecbuild_add_test( TARGET eccodes_t_grib_ccsds
                  TYPE SCRIPT
                  CONDITION HAVE_AEC
                  COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/grib_ccsds.sh
                  TEST_DEPENDS eccodes_download_gribs
)

ecbuild_add_test( TARGET eccodes_t_grib_check_param_concepts
                  TYPE SCRIPT
                  CONDITION ENABLE_EXTRA_TESTS
                  COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/grib_check_param_concepts.sh
)
# Performance test. Must have -DENABLE_GRIB_TIMER=ON
ecbuild_add_test( TARGET eccodes_t_ecc-386
                  TYPE SCRIPT
                  CONDITION ENABLE_EXTRA_TESTS AND ENABLE_GRIB_TIMER
                  COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/ecc-386.sh
                  TEST_DEPENDS eccodes_download_gribs
)

=== tigge/CMakeLists.txt ===
# tigge
ecbuild_add_executable(TARGET   tigge_check
                       SOURCES  tigge_check.c
                       INCLUDES ${ECCODES_EXTRA_INCLUDE_DIRS}
                       LIBS     eccodes
                       )


ecbuild_add_executable(TARGET   tigge_name 
                       SOURCES  tigge_name.c
                       INCLUDES ${ECCODES_EXTRA_INCLUDE_DIRS}
                       LIBS     eccodes
                       )

ecbuild_add_executable(TARGET   tigge_accumulations
                       SOURCES  tigge_accumulations.c
                       INCLUDES ${ECCODES_EXTRA_INCLUDE_DIRS}
                       LIBS     eccodes
                       )

ecbuild_add_executable(TARGET   tigge_split
                       SOURCES  tigge_split.c
                       INCLUDES ${ECCODES_EXTRA_INCLUDE_DIRS}
                       LIBS     eccodes
                       )

=== tools/CMakeLists.txt ===
#
# Copyright 2005-2017 ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
#
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.
#

# tools library
ecbuild_add_library( TARGET    grib_tools
                     TYPE      STATIC
                     NOINSTALL
                     SOURCES   grib_tools.c grib_options.c grib_tools.h
                     LIBS      eccodes )

# tools binaries
list( APPEND grib_tools_bins
             codes_info codes_count codes_split_file
             grib_histogram grib_filter grib_ls grib_dump grib_merge
             grib2ppm grib_set grib_get grib_get_data grib_copy
             grib_compare codes_parser grib_index_build
             bufr_ls bufr_dump bufr_set bufr_get
             bufr_copy bufr_compare bufr_index_build
             gts_get gts_compare gts_copy gts_dump gts_filter gts_ls
             metar_dump metar_ls metar_compare metar_get metar_filter metar_copy
             )

list( APPEND grib_tools_bins_EXTRA
             big2gribex
             gg_sub_area_check
             grib_repair
             grib_to_json
             grib_check_gaussian_grid
             )

# Install generic tools
foreach( tool ${grib_tools_bins} )
    # here we use the fact that each tool has only one C file that matches its name
    ecbuild_add_executable( TARGET     ${tool}
                            SOURCES    ${tool}.c
                            LIBS       grib_tools )
endforeach()

# Install extra tools
# User must run cmake with -DECCODES_INSTALL_EXTRA_TOOLS=ON
foreach( tool ${grib_tools_bins_EXTRA} )
    ecbuild_add_executable( TARGET     ${tool}
                            SOURCES    ${tool}.c
                            CONDITION  ECCODES_INSTALL_EXTRA_TOOLS
                            LIBS       grib_tools )
endforeach()

# grib_count/bufr_count tools. Same source code, different executable names
ecbuild_add_executable( TARGET     grib_count
                        SOURCES    codes_count.c
                        LIBS       grib_tools  )
ecbuild_add_executable( TARGET     bufr_count
                        SOURCES    codes_count.c
                        LIBS       grib_tools  )

# grib to netcdf is optional
ecbuild_add_executable( TARGET     grib_to_netcdf
                        SOURCES    grib_to_netcdf.c
                        INCLUDES   ${NETCDF_INCLUDE_DIRS}
                        CONDITION  HAVE_NETCDF
                        LIBS       grib_tools ${NETCDF_LIBRARIES})


ecbuild_add_executable( TARGET     grib_list_keys
                        SOURCES    list_keys.c
                        CONDITION  ECCODES_INSTALL_EXTRA_TOOLS
                        LIBS       grib_tools  )

ecbuild_add_executable( TARGET     codes_bufr_filter
                        SOURCES    bufr_filter.c
                        LIBS       grib_tools  )


# grib1to2 script needs to be generated before installation
if (ECCODES_INSTALL_EXTRA_TOOLS)
    configure_file( grib1to2.in  grib1to2 )
    install( FILES ${CMAKE_CURRENT_BINARY_DIR}/grib1to2
             DESTINATION ${INSTALL_BIN_DIR}
             PERMISSIONS OWNER_EXECUTE OWNER_WRITE OWNER_READ
                         GROUP_EXECUTE GROUP_READ
                         WORLD_EXECUTE WORLD_READ )
endif()
########################################

# BUFR compare script
install( FILES ${CMAKE_CURRENT_SOURCE_DIR}/bufr_compare_dir
         DESTINATION ${INSTALL_BIN_DIR}
         PERMISSIONS OWNER_EXECUTE OWNER_WRITE OWNER_READ
                     GROUP_EXECUTE GROUP_READ
                     WORLD_EXECUTE WORLD_READ )


# bufr_filter script (See ECC-205)
execute_process( COMMAND ${CMAKE_COMMAND} -E copy_if_different
    ${PROJECT_SOURCE_DIR}/tools/bufr_filter
    ${CMAKE_BINARY_DIR}/bin/ )

install( FILES ${CMAKE_CURRENT_SOURCE_DIR}/bufr_filter
         DESTINATION ${INSTALL_BIN_DIR}
         PERMISSIONS OWNER_EXECUTE OWNER_WRITE OWNER_READ
                     GROUP_EXECUTE GROUP_READ
                     WORLD_EXECUTE WORLD_READ )

=== data/gts/CMakeLists.txt ===
# data/gts/CMakeLists.txt
# Download all the GTS data and reference files from website
#

FILE(READ "gts_data_files.txt" gts_files_to_download)
STRING(REGEX REPLACE "\n" ";" gts_files_to_download "${gts_files_to_download}")

FILE(READ "gts_ref_files.txt" gts_refs_to_download)
STRING(REGEX REPLACE "\n" ";" gts_refs_to_download "${gts_refs_to_download}")


ecbuild_get_test_multidata(
     TARGET eccodes_download_gts
     NOCHECK
     NAMES ${gts_files_to_download} ${gts_refs_to_download}
)

# Copy other files - e.g. text files etc from the source data/gts dir
LIST(APPEND other_files
    gts_data_files.txt
    gts_ref_files.txt
)

foreach( file ${other_files} )
   execute_process( COMMAND ${CMAKE_COMMAND} -E copy_if_different ${CMAKE_CURRENT_SOURCE_DIR}/${file} ${CMAKE_CURRENT_BINARY_DIR} )
endforeach()

=== examples/C/CMakeLists.txt ===
# examples/C/CMakeLists.txt

# Configure the file which all CMake tests will include
configure_file( include.ctest.sh.in  include.ctest.sh  @ONLY )

execute_process( COMMAND ${CMAKE_COMMAND} -E copy_if_different ${CMAKE_CURRENT_SOURCE_DIR}/include.sh ${CMAKE_CURRENT_BINARY_DIR} )

# Build the executables used by test scripts
########################################################################
list( APPEND test_bins
      grib_nearest
      grib_set_bitmap
      grib_iterator
      grib_get_keys
      grib_print_data
      grib_set_keys
      grib_index
      set_missing
      grib_keys_iterator
      grib_set_data
      mars_param
      values_check
      box
      grib_multi
      multi2
      grib_multi_write
      grib_precision
      grib_set_pv
      grib_list
      grib_get_data
      sections_copy
      grib_iterator_bitmap
      large_grib1
      grib_clone
      grib_copy_message
      grib_ensemble_index
      get_product_kind
      bufr_copy_data
      bufr_attributes
      bufr_clone
      bufr_expanded
      bufr_get_keys
      bufr_get_string_array
      bufr_keys_iterator
      bufr_missing
      bufr_read_header
      bufr_read_scatterometer
      bufr_read_synop
      bufr_read_temp
      bufr_set_keys
      bufr_subset
)
foreach( tool ${test_bins} )
    ecbuild_add_executable( TARGET    c_${tool}
                            NOINSTALL
                            SOURCES   ${tool}.c
                            LIBS      eccodes
    )
endforeach()

# Now add each test (shell scripts)
########################################################################
list( APPEND tests
   grib_iterator
   grib_get_keys
   grib_print_data
   grib_set_keys
   grib_keys_iterator
   grib_multi
   grib_multi_write
   grib_precision
   grib_clone
   grib_copy_message
   grib_ensemble_index
   grib_set_pv
   grib_set_data
   grib_set_bitmap
   grib_list
   grib_get_data
   large_grib1
   set_missing
   sections_copy
   bufr_attributes
   bufr_copy_data
   bufr_clone
   bufr_expanded
   bufr_get_keys
   bufr_get_string_array
   bufr_keys_iterator
   bufr_missing
   bufr_read_header
   bufr_read_scatterometer
   bufr_read_synop
   bufr_read_temp
   bufr_set_keys
   bufr_subset
   get_product_kind
)
foreach( test ${tests} )
    ecbuild_add_test( TARGET eccodes_c_${test}
                      TYPE       SCRIPT
                      COMMAND    ${CMAKE_CURRENT_SOURCE_DIR}/${test}.sh
                      TEST_DEPENDS eccodes_download_gribs eccodes_download_bufrs
    )
endforeach()

########################################################################
# Tests which are conditional
if( ENABLE_EXTRA_TESTS AND HAVE_ECCODES_THREADS )
    # For POSIX threads
    LIST(APPEND pthread_tests grib_pthreads bufr_pthreads)
    foreach( test ${pthread_tests} )
        ecbuild_add_executable( TARGET    c_${test}
                                NOINSTALL
                                SOURCES   ${test}.c
                                LIBS      eccodes
        )
        ecbuild_add_test( TARGET       eccodes_c_${test}
                          TYPE         SCRIPT
                          COMMAND      ${CMAKE_CURRENT_SOURCE_DIR}/${test}.sh
                          TEST_DEPENDS eccodes_download_gribs eccodes_download_bufrs
        )
    endforeach()
endif()


########################################################################
# Tests with no script
ecbuild_add_test(
    TARGET    eccodes_c_new_sample
    SOURCES   new_sample.c
    LIBS      eccodes
    ARGS      "out.grib"
    ENVIRONMENT "ECCODES_SAMPLES_PATH=${PROJECT_SOURCE_DIR}/samples" "ECCODES_DEFINITION_PATH=${PROJECT_SOURCE_DIR}/definitions"
)

=== examples/F90/CMakeLists.txt ===
# examples/F90/CMakeLists.txt

# Configure the file which all CMake tests will include
configure_file( include.ctest.sh.in  include.ctest.sh  @ONLY )

execute_process( COMMAND ${CMAKE_COMMAND} -E copy_if_different ${CMAKE_CURRENT_SOURCE_DIR}/include.sh ${CMAKE_CURRENT_BINARY_DIR} )

# Build the executables used by test scripts
################################################
list( APPEND tests
      grib_index
      grib_copy_message
      bufr_copy_message
      grib_get_keys
      grib_get_data
      get_pl
      get_pv
      grib_keys_iterator
      grib_multi_write
      grib_multi
      grib_nearest
      grib_precision
      grib_print_data
      grib_set_keys
      grib_set_bitmap
      grib_set_missing
      grib_set_pv
      grib_set_data
      grib_samples
      grib_count_messages
      grib_count_messages_multi
      grib_copy_namespace
      read_message
      read_from_file
      get_set_uuid
      grib_clone
      bufr_attributes
      bufr_copy_data
      bufr_clone
      bufr_expanded
      bufr_get_keys
      bufr_get_string_array
      bufr_keys_iterator
      bufr_read_header
      bufr_read_scatterometer
      bufr_read_synop
      bufr_read_temp
      bufr_read_tropical_cyclone
      bufr_set_keys
      bufr_copy_keys
      bufr_subset
      get_product_kind
)

foreach( tool ${tests} )

    ecbuild_add_test( TARGET eccodes_f_${tool}
                      SOURCES   ${tool}.f90
                      LINKER_LANGUAGE Fortran
                      LIBS      eccodes_f90 eccodes
                      CONDITION HAVE_FORTRAN
                      RESOURCES bufr_read_scatterometer_f.ref
                      COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/${tool}.sh
                      TEST_DEPENDS eccodes_download_gribs eccodes_download_bufrs
    )
endforeach()

# Executables without a shell script
# TODO
ecbuild_add_executable( TARGET    eccodes_f_new_from_file
                        NOINSTALL
                        SOURCES   new_from_file.f90
                        CONDITION HAVE_FORTRAN
                        LINKER_LANGUAGE Fortran
                        LIBS      eccodes_f90 eccodes
)
ecbuild_add_executable( TARGET    eccodes_f_grib_set_gvc
                        NOINSTALL
                        SOURCES   grib_set_gvc.f90
                        CONDITION HAVE_FORTRAN
                        LINKER_LANGUAGE Fortran
                        LIBS      eccodes_f90 eccodes
)
ecbuild_add_executable( TARGET    eccodes_f_grib_print_data_static
                        NOINSTALL
                        SOURCES   grib_print_data_static.f90
                        CONDITION HAVE_FORTRAN
                        LINKER_LANGUAGE Fortran
                        LIBS      eccodes_f90 eccodes
)


# # Note extra dependency
# ecbuild_add_test( TARGET eccodes_f_set_test
#                   TYPE SCRIPT
#                   DEPENDS set_gvc set
#                   COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/set.sh
# )

=== debian/changelog ===
eccodes (2.6.0-2) unstable; urgency=medium

  * Point VCS in debian/control to salsa.debian.org
  * Standards-Version: 4.1.3; no changes required
  * Drop build-path of filename from gfortran mod files for reproducibility

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 01 Feb 2018 11:23:32 +0000

eccodes (2.6.0-1) unstable; urgency=medium

  * New upstream release
  * Standards-Version: 4.1.2; no changes required

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 24 Dec 2017 07:15:53 +0000

eccodes (2.5.0-4) unstable; urgency=medium

  * Re-enable DISABLE_OS_CHECK. 

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 20 Nov 2017 09:13:49 +0000

eccodes (2.5.0-3) unstable; urgency=medium

  * Also sanitize eccodes_ecbuild_config.h for reproducibility

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 21 Oct 2017 19:08:30 +0100

eccodes (2.5.0-2) unstable; urgency=medium

  * Sanitize cmake scripts further, removing build paths for reproduciblity.

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 11 Oct 2017 13:19:59 +0100

eccodes (2.5.0-1) unstable; urgency=medium

  * New upstream release
  * Standards-Version: 4.1.1
  * Remove obsolete DISABLE_OS_CHECK

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 03 Oct 2017 19:56:11 +0100

=== debian/control ===
Source: eccodes
Section: science
Priority: optional
Maintainer: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper (>= 10), 
  dh-buildinfo, 
  cmake,
  libjpeg-dev, 
  libpng-dev, 
  gfortran, 
  flex, 
  bison, 
  quilt,
  python3-all-dev, 
  python3-numpy, 
  dh-python,
  python3-six, 
  python3-setuptools, 
  swig, 
  doxygen,
  libboost-dev, 
  libhdf5-dev, 
  chrpath,
  libaec-dev,
  libnetcdf-dev,
  libopenjp2-7-dev
Build-Conflicts: libopenjpeg-dev, libgrib-api-dev
Standards-Version: 4.1.3
X-Python-Version: >= 2.7
Homepage: https://software.ecmwf.int/wiki/display/ECC/ecCodes+Home
Vcs-Browser: https://salsa.debian.org:/science-team/eccodes.git
Vcs-Git: https://salsa.debian.org:/science-team/eccodes.git

Package: libeccodes0
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}, libeccodes-data
Description: GRIB and BUFR enecoding/encoding software library
 ecCodes is the ECMWF encoding/decoding software for GRIB and BUFR.
 .
 It is a replacement for the grib-api and emoslib libraries.
 .
 ECMWF is the European Centre for Medium-Range Weather Forecasts.

Package: libeccodes-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: GRIB and BUFR enecoding/encoding software library - data
 ecCodes is the ECMWF encoding/decoding software for GRIB and BUFR.
 
Package: libeccodes-dev
Section: libdevel
Architecture: any
Depends: libeccodes0 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends},
  libaec-dev, libpng-dev, libjpeg-dev, zlib1g-dev
Conflicts: libgrib-api-dev
Description: GRIB and BUFR decoding/encoding software library (development)
 ecCodes is the ECMWF encoding/decoding software for GRIB and BUFR.
 .
 ECMWF is the European Centre for Medium-Range Weather Forecasts.
 
Package: libeccodes-tools
Section: utils
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, mksh | pdksh | zsh | ksh
Conflicts: libgrib-api-tools
Breaks: libemos-bin (<< 2:4.4.5-2)
Description: GRIB decoding/encoding software (utilities)
 ecCodes is the ECMWF encoding/decoding software for GRIB and BUFR.
 .
 This is a useful set of command line tools to give quick access to grib
 messages.
 .
 ECMWF is the European Centre for Medium-Range Weather Forecasts.

Package: python3-eccodes
Section: python
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, ${python3:Depends}
Conflicts: libgrib-api-dev
Breaks: python3-gribapi
Replaces: python3-gribapi
Provides: ${python3:Provides}
Description: Python module for the ECMWF GRIB API library
 ecCodes is the ECMWF encoding/decoding software for GRIB and BUFR.
 .
 This is a Python wrapper for the GRIB API library.
 .
 ECMWF is the European Centre for Medium-Range Weather Forecasts.

Package: libeccodes-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}, libjs-jquery
Description: GRIB decoding/encoding software (documentation)
 ecCodes is the ECMWF encoding/decoding software for GRIB and BUFR.
 .
 This provides the documentation for the library.
 .
 ECMWF is the European Centre for Medium-Range Weather Forecasts.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
LIBDIR=/usr/lib/$(DEB_HOST_MULTIARCH)
BUILDDIR=$(CURDIR)/debian/build
UPSTREAM_VERSION=$(shell dpkg-parsechangelog | sed -ne 's/^Version: \(.*\)-.*/\1/p' | sed -e 's/\+.*//; s/^[0-9]://')

# For hardening
CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
CFLAGS:=$(shell dpkg-buildflags --get CFLAGS) $(CPPFLAGS) #  -fPIC
CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS) $(CPPFLAGS)
LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS)

export LDFLAGS CFLAGS CPPFLAGS CXXFLAGS

PY3VERS:=$(shell py3versions -s)
PY3VERSD:=$(shell py3versions -d)

# Don't test on mips. will time out most of the time on low-powered archs
DO_TEST:=true
ARCH:=$(shell dpkg --print-architecture)
ifeq ($(ARCH), mips)
DO_TEST:=false
endif
ifeq ($(ARCH),hppa)
DO_TEST:=false
endif

BUILD_FLAGS =  \
	-DCMAKE_BUILD_TYPE=Release \
	-DDISABLE_OS_CHECK=ON \
	-DENABLE_INSTALL_ECCODES_DEFINITIONS=ON \
	-DENABLE_INSTALL_ECCODES_SAMPLES=ON \
	-DENABLE_PNG=ON \
	-DENABLE_AEC=ON \
	-DENABLE_RPATHS=OFF \
	-DENABLE_RELATIVE_RPATHS=OFF \
	-DENABLE_MEMFS=ON \
	-DHAVE_BIT_REPRODUCIBLE=ON \
	-DCMAKE_C_CFLAGS="${CFLAGS} ${LDFLAGS}" \
	-DENABLE_ALIGN_MEMORY=ON \
	-DENABLE_GRIB_TIMER=ON \
	-DENABLE_ECCODES_OMP_THREADS=ON \
	-DENABLE_PYTHON=ON \
	-DPYTHON_EXECUTABLE=/usr/bin/python3 

%:
	dh $@ --buildsystem=cmake --with=python3 --builddirectory=${BUILDDIR} --no-parallel

override_dh_auto_configure:
	F77=gfortran dh_auto_configure -- \
	    ${BUILD_FLAGS}
	( cd ${BUILDDIR}/data ; tar axpf $(CURDIR)/../eccodes_$(UPSTREAM_VERSION).orig-data.tar.xz )
	( cd python ; swig -python -module gribapi_swig -o swig_wrap_numpy.c gribapi_swig.i )

override_dh_install:
	# Move to multiarch dir
	mkdir -p debian/tmp/${LIBDIR}
	cp -a debian/tmp/usr/lib/lib* debian/tmp/${LIBDIR}
	cp -a debian/tmp/usr/lib/pkgconfig debian/tmp/${LIBDIR}
	for d in libeccodes_memfs.so libeccodes_f90.so	libeccodes.so ; do \
		cp debian/tmp/$(LIBDIR)/$$d.0 debian/tmp/$(LIBDIR)/$$d.0.0.0 ; \
		chrpath -d debian/tmp/$(LIBDIR)/$$d.0.0.0 ; done
	dh_link -p libeccodes0 $(LIBDIR)/libeccodes.so.0.0.0  $(LIBDIR)/libeccodes.so.0
	dh_link -p libeccodes0 $(LIBDIR)/libeccodes_f90.so.0.0.0  $(LIBDIR)/libeccodes_f90.so.0
	dh_link -p libeccodes0 $(LIBDIR)/libeccodes_memfs.so.0.0.0  $(LIBDIR)/libeccodes_memfs.so.0
	dh_link -p libeccodes-dev $(LIBDIR)/libeccodes.so.0.0.0 $(LIBDIR)/libeccodes.so
	dh_link -p libeccodes-dev $(LIBDIR)/libeccodes_f90.so.0.0.0 $(LIBDIR)/libeccodes_f90.so
	dh_link -p libeccodes-dev $(LIBDIR)/libeccodes_memfs.so.0.0.0 $(LIBDIR)/libeccodes_memfs.so
	for py in $(PY3VERS); do \
		(cd debian/build/python && $$py ./setup.py install --prefix=$(CURDIR)/debian/tmp/usr ) ; \
		done
	chrpath -d ./debian/tmp/usr/lib/python*/site-packages/gribapi/*.so
	for d in debian/tmp/usr/bin/* ; do \
		( chrpath -d $$d || echo "Ignoring chrpath error for non-ELF $d" ); \
		done
	dh_numpy3
	dh_install
	#
	# Setup cmake files for magics++, metview, etc.
	#
	mkdir -p debian/libeccodes-dev/$(LIBDIR)/cmake/eccodes
	cp debian/tmp/usr/share/eccodes/cmake/* debian/libeccodes-dev/$(LIBDIR)/cmake/eccodes
	sed -e 's%$${_IMPORT_PREFIX}%/usr%' \
	       < debian/tmp/usr/share/eccodes/cmake/eccodes-targets-release.cmake | \
	sed -e 's%-l${PY3VERSD} %%g' | \
	sed -e 's%/usr/lib/libeccodes%${LIBDIR}/libeccodes%' | \
	sed -e 's%${LIBDIR}/libopenjpeg.so;%%' | sed -e 's%;${LIBDIR}/libpng.so%%g' \
	      > debian/libeccodes-dev/$(LIBDIR)/cmake/eccodes/eccodes-targets-release.cmake
	sed -e 's%;${LIBDIR}/libopenjpeg.so%%g' \
		< debian/tmp/usr/share/eccodes/cmake/eccodes-config.cmake | \
	sed -e 's%-l${PY3VERSD} %%g' | \
	sed -s 's%/usr/include/${PY3VERSD};%%g' | sed -e 's%/usr/include/python2.7;%%g' | \
	sed -e 's%;${LIBDIR}/libpng.so%%g' \
		> debian/libeccodes-dev/$(LIBDIR)/cmake/eccodes/grib_api-config.cmake
	# For bit-reproducibility, sanitize the build paths
	for f in eccodes-config.cmake eccodes-import.cmake grib_api-config.cmake ; do \
		sed -e 's%${CURDIR}%/build/eccodes%g' < debian/libeccodes-dev/$(LIBDIR)/cmake/eccodes/$$f \
		> debian/libeccodes-dev/$(LIBDIR)/cmake/eccodes/x; \
		mv debian/libeccodes-dev/$(LIBDIR)/cmake/eccodes/x  debian/libeccodes-dev/$(LIBDIR)/cmake/eccodes/$$f ; \
		done
	sed -e 's%${CURDIR}%/build/eccodes%g' < debian/libeccodes-dev/usr/include/eccodes_ecbuild_config.h \
		> debian/libeccodes-dev/usr/include/x
	mv debian/libeccodes-dev/usr/include/x debian/libeccodes-dev/usr/include/eccodes_ecbuild_config.h
	# Fix build-path in gfortran mod files
	./debian/sanitize-mod debian/libeccodes-dev/usr/include/eccodes.mod
	./debian/sanitize-mod debian/libeccodes-dev/usr/include/grib_api.mod

override_dh_auto_clean:
	dh_auto_clean
	# Things that upstream leaves behind
	find . -name '*.pyc' -delete
	rm -f configure.ac configure configure.in
	rm -f tests/bitmap.rules tests/out.grib1 tests/out.grib2 tests/out.gribidx \
	      tests/rules tests/simple_ieee_test.grib1.txt tests/statistics.filter \
	      tests/statistics.out tests/x.grib \
	      data/change_scanning_rotated_ll.filter examples/F90/index.idx

override_dh_fixperms:
	dh_fixperms
	test -e /usr/bin/dh_buildinfo && dh_buildinfo
	-chmod -x debian/libeccodes-dev/usr/share/doc/libeccodes-dev/examples/F90/include.sh
	-chmod +x debian/libeccodes-data/usr/share/eccodes/definitions/installDefinitions.sh
	rm -f debian/libeccodes-doc/usr/share/doc/libeccodes-doc/html/jquery.js
	-ln -s ../../../javascript/jquery/jquery.js debian/libeccodes-doc/usr/share/doc/libeccodes-doc/html/jquery.js

override_dh_auto_test:
	$(DO_TEST) && ( LD_LIBRARY_PATH=$(CURDIR)/debian/build/lib dh_auto_test  ) || true

=== debian/watch ===
version=3
https://software.ecmwf.int/wiki/display/ECC/Releases /wiki/download/attachments/45757960/eccodes\-(.+)\-Source\.tar\.gz\?api=v2
